; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Botik::Key Pro"
!define PRODUCT_EXE_NAME "BotikKeyPro"
!define PRODUCT_VERSION "1.1.2.460-0.85"
!define PRODUCT_PUBLISHER "Alexander V. Melnikoff"
!define PRODUCT_WEB_SITE "http://www.botik.ru/~botik-key-pro/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\bkpmgr32.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\BotikKey Pro"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor bzip2

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"
!define MUI_WELCOMEFINISHPAGE_BITMAP "graphics\orange-wizard.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "graphics\orange-wizard-uninstall.bmp"
!define MUI_HEADERIMAGE # Turn on header image bitmap
!define MUI_HEADERIMAGE_BITMAP "graphics\orange-header.bmp"
!define MUI_UNHEADERIMAGE_BITMAP "graphics\orange-header-uninstall.bmp"
!define MUI_WELCOMEPAGE_TITLE_3LINES
!define MUI_FINISHPAGE_TITLE_3LINES

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME

; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "..\license_eng.txt"

; Directory page
!insertmacro MUI_PAGE_DIRECTORY

; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT_EXE_NAME}"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Finish page
!define MUI_FINISHPAGE_RUN # "$INSTDIR\bkpmgr32.exe"
!define MUI_FINISHPAGE_RUN_FUNCTION onFinishRun
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!define MUI_WELCOMEPAGE_TITLE_3LINES
!define MUI_FINISHPAGE_TITLE_3LINES

!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Uninstall finish page
!insertmacro MUI_UNPAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_EXE_NAME}Setup_${PRODUCT_VERSION}.exe"
InstallDir "$PROGRAMFILES\${PRODUCT_EXE_NAME}"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show
LicenseBkColor FFFFFF
XPStyle on

; Version info tab

Function onFinishRun
  ClearErrors

  ExecWait "$INSTDIR\bkpsvc32.exe -start"

  IfErrors ErrorHandler

  Exec "$INSTDIR\bkpmgr32.exe"

ErrorHandler:
; Do nothing...
FunctionEnd

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Section "MainSection" SEC01
  SetShellVarContext all
  SetOutPath "$INSTDIR"
  SetOverwrite on
  
  File "..\bin\bkpmgr32.exe"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Manager.lnk" "$INSTDIR\bkpmgr32.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Key Utility.lnk" "$INSTDIR\pw2key32.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Help.lnk" "$INSTDIR\help.chm"
  CreateShortCut "$DESKTOP\${PRODUCT_EXE_NAME} Manager.lnk" "$INSTDIR\bkpmgr32.exe"
  File "..\bin\bkpsvc32.exe"
  File "..\bin\pw2key32.exe"
  File "..\bin\md5.dll"
  File "..\license_eng.txt"
  File "..\license_rus.txt"
  File "..\credits_rus.txt"
  File "..\changelog_rus.txt"
  File "..\bin\bkpmgr32.exe.manifest"
  File "..\bin\pw2key32.exe.manifest"
  File "..\bin\help.chm"
  File "..\bin\install.bat"
  File "..\bin\uninstall.bat"
  File "..\bin\message.wav"
  File "..\bin\error.wav"
SectionEnd

Section -AdditionalIcons
  SetShellVarContext all
  
  WriteIniStr "$INSTDIR\${PRODUCT_EXE_NAME} Homepage.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Homepage.lnk" "$INSTDIR\${PRODUCT_EXE_NAME} Homepage.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\License (English).lnk" "$INSTDIR\license_eng.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\License (Russian).lnk" "$INSTDIR\license_rus.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\bkpmgr32.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\bkpmgr32.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  
  ; Execute bkpsvc32.exe to register service programm.
  ExecWait "$INSTDIR\bkpsvc32.exe -install"
SectionEnd


;Function un.onUninstSuccess
;  HideWindow
;  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
;FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
;  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
;  Abort
FunctionEnd

Section Uninstall
  SetShellVarContext all
  
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  
  ; Execute bkpsvc32.exe to unregister service programm.
  ExecWait "$INSTDIR\bkpsvc32.exe -uninstall"
  
  Delete "$INSTDIR\${PRODUCT_EXE_NAME} Homepage.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\changelog_eng.txt"
  Delete "$INSTDIR\changelog_rus.txt"
  Delete "$INSTDIR\credits_eng.txt"
  Delete "$INSTDIR\credits_rus.txt"
  Delete "$INSTDIR\license_eng.txt"
  Delete "$INSTDIR\license_rus.txt"
  Delete "$INSTDIR\bkpmgr32.exe.manifest"
  Delete "$INSTDIR\pw2key32.exe.manifest"
  Delete "$INSTDIR\help.chm"
  Delete "$INSTDIR\install.bat"
  Delete "$INSTDIR\uninstall.bat"
  Delete "$INSTDIR\message.wav"
  Delete "$INSTDIR\error.wav"
  Delete /REBOOTOK "$INSTDIR\pw2key32.exe"
  Delete /REBOOTOK "$INSTDIR\md5.dll"
  Delete /REBOOTOK "$INSTDIR\bkpsvc32.exe"
  Delete /REBOOTOK "$INSTDIR\bkpmgr32.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Homepage.lnk"
  Delete "$DESKTOP\${PRODUCT_EXE_NAME} Manager.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Manager.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Key Utility.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\License (English).lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\License (Russian).lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Help.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
