/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __BOTIKKEYPRO_H__
#define __BOTIKKEYPRO_H__

// Window class names.
#define ABK_WNDCLS_LOG_VIEWER			_T("5a739dd6-9e6d-47d7-a492-5eaf52bc0df9")

// Manager mutex name.
#define ABK_MNGR_MUTEX_NAME				_T("c06e6e86-f8f3-4c9a-b18f-631c8a982d99")
#define ABK_SVC_MUTEX_NAME				_T("60f923f5-b402-48a3-a975-8cb66ea32213")

// Max loading string from resources.
#define MAX_LOADSTRING					512 

#define	ABK_BKEY_SRV_DEF_PORT			12040 // Default BotikKey server port
#define ABK_BKEY_SRV_CON_TIMEOUT		60 * 1000 // 60 seconds

// Access levels.
#define ABK_ACCESS_UNSPEC				0x00
#define ABK_ACCESS_NONE					0x01
#define ABK_ACCESS_LOCAL				0x02
#define ABK_ACCESS_WORLD				0x04
#define ABK_ACCESS_CHANGING				0x08 // this flag can be combined with above

#define ABK_ACCESS_LEAVE				ABK_ACCESS_UNSPEC

#define ABK_ACCESS_MASK					(ABK_ACCESS_NONE|ABK_ACCESS_LOCAL|ABK_ACCESS_WORLD)

// Service's statuses.
// bit 0-3  -- service status (stopped or running)
// bit 4-7  -- service current bussiness.
// bit 8-11 -- service reason
#define ABK_SVC_STOPPED					SERVICE_STOPPED
#define ABK_SVC_RUNNING					SERVICE_RUNNING
#define ABK_SVC_PAUSED					SERVICE_PAUSED

#define ABK_SVC_NOTHING					0x00000000
#define ABK_SVC_CONNECTING				0x00000010
#define ABK_SVC_CONNECTED				0x00000020

#define ABK_SVC_CONNECT_FAILED			0x00000100

#define ABK_SVC_STATUS_MASK				0x0000000f
#define ABK_SVC_BUSINESS_MASK			0x000000f0
#define ABK_SVC_REASON_MASK				0x00000f00

// Password place.
#define ABK_PASSWD_PLACE_SELF			0x00
#define ABK_PASSWD_PLACE_ENV			0x01
#define ABK_PASSWD_PLACE_REG			0x02
#define ABK_PASSWD_PLACE_DEF_FILE		0x03
#define ABK_PASSWD_PLACE_SELF_FILE		0x04

#define ABK_MANAGER_NAME				_T("Botik::Key Pro Manager")
#define ABK_SERVICE_NAME				_T("Botik::Key Pro Service")
#define ABK_SERVICE_NAME_FOR_SCM		_T("BOTIKKEYPROSVC") // This is service name for service control manager database.

#define ABK_DEV_LINK_EMAIL				_T("mailto:botikkeypro@stitch.pereslavl.ru")
#define ABK_DEV_LINK_SITE				_T("http://www.botik.ru/~botik-key-pro/") //_T("http://joker.u.pereslavl.ru/~alexvm/projects/bkp/")

#define ABK_BOTIK_KEY_ENV_VAR_NAME		_T("BOTIKKEY")
#define ABK_BOTIK_KEY_DEF_FILE_NAME		_T("default.pswd")
#define ABK_BOTIK_KEY_REG_VAR_NAME		_T("AccessKey")

#define ABK_MD5_HASH_LEN				32

// Registry keys.
#define REG_AUTOSTART_PATH				_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run")
#define REG_SETTINGS_PATH				_T("Software\\Synapsis\\BotikKeyPro")
#define REG_EVENTLOG_PATH				_T("SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\")

// Manager settings.
#define REG_MNGR_AUTOSTART_VAL			_T("BotikKeyProMngr")
#define REG_STARTUP_MODE_VAL			_T("StartupMode")
#define REG_HIDE_MIN_VAL				_T("HideWhenMinimize")
#define REG_HIDE_CLOSE_VAL				_T("HideWhenClose")
#define REG_ONE_CLICK_VAL				_T("OpenOneClick")
#define REG_FORCE_LOGVIEWER_VAL			_T("ForceLogviewer")
#define REG_ASTERISKS_VAL				_T("ShowAsterisks")
#define REG_PWD_ASTERISKS_VAL			_T("ShowPwdAsterisks")
#define REG_KEY_ASTERISKS_VAL			_T("ShowKeyAsterisks")
#define REG_SHOWKEY_VAL					_T("ShowKeySymbols")
#define REG_SWITCH_WHEN_CLOSE_VAL		_T("SwitchWhenClose")
#define REG_SWITCH_WHEN_START_VAL		_T("SwitchWhenStart")

#define REG_LOGVIEWER_CX_VAL			_T("LogviewerCx")
#define REG_LOGVIEWER_CY_VAL			_T("LogviewerCy")
#define REG_LOGVIEWER_ISMAX_VAL			_T("LogviewerIsMax")
#define REG_LOGVIEWER_TOOLBAR_VAL		_T("LogviewerToolbar")
#define REG_LOGVIEWER_STATUSBAR_VAL		_T("LogviewerStatusbar")
#define REG_LOGVIEWER_AUTOSCROLL_VAL	_T("Autoscroll")
#define REG_LOGVIEWER_FIRST_COL_VAL		_T("FirstColWidth")
#define REG_LOGVIEWER_SECOND_COL_VAL	_T("SecondColWidth")
#define REG_LOGVIEWER_MAX_ENTRY			_T("MaxEventlogEntry")
#define REG_LOGVIEWER_PLAYSOUND			_T("PlaySound")

// Service settings.
#define REG_SVC_AUTOSTART_VAL			_T("AltBotikKeySvc")
#define REG_SWITCH_WHEN_SVC_START_VAL	_T("SwitchWhenSvcStart")
#define REG_PASSWD_FILE_VAL				_T("PasswdFile")
#define REG_PASSWD_PLACE_VAL			_T("PasswdPlace")
#define REG_LAST_ACCESS_MODE			_T("LastAccessMode")
#define REG_BKEY_SRV_PORT				_T("ServerPortNumber")
#define REG_BKEY_SRV_ADDR				_T("ServerAddress")
#define REG_BKEY_SRV_PORT_USE_STD		_T("UseStandardPortNumber")
#define REG_BKEY_SRV_USE_DEF_GW_ADDR	_T("UseDefaultGatewayAddress")
#define REG_BKEY_SRV_WRITE_LOG			_T("WriteLogFile")
#define REG_BKEY_SRV_INFORM_MNGR		_T("InformManager")

// 
inline LPSTR AccessModeToString(DWORD dwMode_)
{
	LPSTR szRet = "";

	if(dwMode_ & ABK_ACCESS_NONE)
		szRet = "NONE";
	else if(dwMode_ & ABK_ACCESS_LOCAL)
		szRet = "LOCAL";
	else if(dwMode_ & ABK_ACCESS_WORLD)
		szRet = "WORLD";

	return(szRet);
};

inline DWORD StringToAccessMode(LPSTR szMode_)
{
	DWORD dwRet = ABK_ACCESS_UNSPEC;

	if(!strcmp(szMode_, "NONE"))
		dwRet = ABK_ACCESS_NONE;
	else if(!strcmp(szMode_, "LOCAL"))
		dwRet = ABK_ACCESS_LOCAL;
	else if(!strcmp(szMode_, "WORLD"))
		dwRet = ABK_ACCESS_WORLD;

	return(dwRet);
};


#endif // __ALTBOTIKKEY_H__




