/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include <math.h>
#include <lmcons.h>
#include <shlwapi.h>
#include "interface_h.h"
#include "dialogs.h"

BKPSYSTEMINFO g_SysInfo;

// Message handler proc for about box.
LRESULT CALLBACK AboutDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	static HCURSOR hHandCur = LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_MY_HAND));
	static HCURSOR hOldCur = NULL;

	switch (uMsg_)
	{
	case WM_INITDIALOG:
		{
			TCHAR szText[MAX_LOADSTRING+1];

			// Version text.
			LoadString(g_hInst, IDS_ABOUT_TITLE, szText, MAX_LOADSTRING);
			SetDlgItemText(hDlg_, IDC_ABOUT_TITLE, szText);			

			// Credits.
			HRSRC hrc;
			HGLOBAL hgl;
			LPTSTR szStr, szPtr;
			DWORD dwSize;

			hrc = FindResource((HMODULE)g_hInst, MAKEINTRESOURCE(IDR_CREDITS), RT_HTML);
			if(hrc == NULL)
				return(FALSE);

			dwSize = SizeofResource((HMODULE)g_hInst, hrc);

			hgl = LoadResource((HMODULE)g_hInst, hrc);
			if(hgl == NULL)
				return(FALSE);

			szPtr = (LPTSTR)LockResource(hgl);
			if(szPtr == NULL)
				return(FALSE);

			szStr = new TCHAR[dwSize + 1];
			memcpy(szStr, szPtr, dwSize);
			szStr[dwSize] = 0;

			SetDlgItemText(hDlg_, IDC_THANKS_TEXT, szStr);

			delete[] szStr;
			FreeResource(hgl);

			// Setup email and URL look and feel like links, color of the lik text is changing in the 
			// WM_CTLCOLORSTATIC message.
			LOGFONT lf;

			// Get default GUI font information.
			GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &lf);

			// Change some params.
			lf.lfUnderline = TRUE;

			HFONT hFont = CreateFont(lf.lfHeight, lf.lfWidth, lf.lfEscapement, 
									lf.lfOrientation, lf.lfWeight, lf.lfItalic, 
									lf.lfUnderline, lf.lfStrikeOut, lf.lfCharSet, 
									lf.lfOutPrecision, lf.lfClipPrecision, lf.lfQuality, 
									lf.lfPitchAndFamily, lf.lfFaceName);

			SendDlgItemMessage(hDlg_, IDC_EMAIL, WM_SETFONT, (WPARAM)hFont, TRUE);
			SendDlgItemMessage(hDlg_, IDC_URL, WM_SETFONT, (WPARAM)hFont, TRUE);

//			if(pEnableThemeDialogTexture)
//				pEnableThemeDialogTexture(hDlg_, 6);

			//HDC hdc = GetWindowDC(GetDlgItem(hDlg_, IDC_EMAIL));
			//SetTextColor(hdc, RGB(0,0,255));
			//SetBkMode(hdc, TRANSPARENT);
		};
		return TRUE;

	case WM_CTLCOLORSTATIC:
		{
/*
			HWND hWnd = (HWND)lParam_;
			HDC hdc = (HDC)wParam_;

			if(hWnd == GetDlgItem(hDlg_, IDC_EMAIL) || hWnd == GetDlgItem(hDlg_, IDC_URL))
			{
//				cfdprintf(_T("WM_CTLCOLORSTATIC"));

				SetBkMode(hdc, TRANSPARENT);
				SelectObject(hdc, (HBRUSH)GetStockObject(NULL_BRUSH)); // DC_BRUSH
				SetTextColor(hdc, RGB(0, 0, 255));

				return(TRUE);
			};
*/
		};
		break;

	case WM_SETCURSOR:
		{
			POINT pt;
			RECT rc1, rc2;

			cfdprintf(_T("WM_SETCURSOR: %d =?= %d"), HIWORD(lParam_), WM_LBUTTONUP);

			GetCursorPos(&pt);

			GetWindowRect(GetDlgItem(hDlg_, IDC_EMAIL), &rc1);
			GetWindowRect(GetDlgItem(hDlg_, IDC_URL), &rc2);

			if(PtInRect(&rc1, pt) || PtInRect(&rc2, pt))
			{
				hOldCur = SetCursor(hHandCur);

				// Clicked...
				if(HIWORD(lParam_) == WM_LBUTTONUP)
				{
					if(PtInRect(&rc1, pt))
					{
						cfdprintf("ABK_DEV_LINK_EMAIL");
						ShellExecute(HWND_DESKTOP, _T("open"), ABK_DEV_LINK_EMAIL, NULL, NULL, SW_SHOWNORMAL);
					}
					else
					{
						ShellExecute(HWND_DESKTOP, _T("open"), ABK_DEV_LINK_SITE, NULL, NULL, SW_SHOWNORMAL);
					};

					MessageBeep(MB_OK);
				};

				return(TRUE);
			}
			else if(hOldCur)
			{
				SetCursor(hOldCur);
				hOldCur = NULL;
				return(TRUE);
			};
		};
		break;

	case WM_COMMAND:
		if (LOWORD(wParam_) == IDOK || LOWORD(wParam_) == IDCANCEL) 
		{
			EndDialog(hDlg_, LOWORD(wParam_));
			return TRUE;
		};
		break;

	case WM_DESTROY:
		DestroyCursor(hHandCur);
		break;
	};


	return FALSE;
};

// Message handler proc for license box.
LRESULT CALLBACK LicenseDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	switch (uMsg_)
	{
	case WM_INITDIALOG:
		{
			HRSRC hrc;
			HGLOBAL hgl;
			LPTSTR szStr, szPtr;
			DWORD dwSize;

			hrc = FindResource((HMODULE)g_hInst, MAKEINTRESOURCE(IDR_GPL_LICENSE), RT_HTML);
			if(hrc == NULL)
				return(FALSE);

			dwSize = SizeofResource((HMODULE)g_hInst, hrc);

			hgl = LoadResource((HMODULE)g_hInst, hrc);
			if(hgl == NULL)
				return(FALSE);

			szPtr = (LPTSTR)LockResource(hgl);
			if(szPtr == NULL)
				return(FALSE);

			szStr = new TCHAR[dwSize + 1];
			memcpy(szStr, szPtr, dwSize);
			szStr[dwSize] = 0;

			SetDlgItemText(hDlg_, IDC_LICENSE_TEXT, szStr);

			delete[] szStr;
			FreeResource(hgl);
		};
		return(TRUE);

	case WM_COMMAND:
		if (LOWORD(wParam_) == IDOK || LOWORD(wParam_) == IDCANCEL) 
		{
			EndDialog(hDlg_, LOWORD(wParam_));
			return(TRUE);
		};
		break;
	};

	return(FALSE);
};

// Message handler proc for set password box.
LRESULT CALLBACK SetPasswdDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	static CHAR szHash[ABK_MD5_HASH_LEN+2];
	static BOOL fUsePasswd = TRUE;

	switch (uMsg_)
	{
	case WM_INITDIALOG:
		{
			SendDlgItemMessage(hDlg_, IDC_ASTERISKS_CHECK, BM_SETCHECK, g_fAsterisks, 0);
			SendDlgItemMessage(hDlg_, IDC_PWD, EM_SETPASSWORDCHAR, 
							   (WPARAM)(g_fAsterisks ? _T('*') : _T(0)), 0);
		};
		return(TRUE);

	case WM_COMMAND:
		switch(LOWORD(wParam_))
		{
		case IDOK:
			cfCHECK_RET(cfRegSaveDWVal(g_hKeyCurUsr, REG_ASTERISKS_VAL, (DWORD)g_fAsterisks));

			if(fUsePasswd)
			{
				LPSTR szPasswd;
				LONG lLen = cfGetDlgItemTextLength(hDlg_, IDC_PWD);

				ZeroMemory(szHash, sizeof(szHash));

				szPasswd = new CHAR[lLen+1];
				szPasswd[0] = 0;
				GetDlgItemTextA(hDlg_, IDC_PWD, szPasswd, lLen+1);
				//cfdprintf("Password: %s", szPasswd);
				md5_md5((LPBYTE)szPasswd, (ULONG)strlen(szPasswd), szHash);
				delete[] szPasswd;
			};

			RpcTryExcept
			{
				//cfdprintf("Hash: %s", szHash);

				SvcSetSessionBotikKey((UCHAR*)szHash);
			}
			RpcExcept(1)
			{
				// XXX 
                MessageBox(NULL, _T("  ."), _T("Botik::Key Pro..."), MB_OK|MB_ICONHAND);
			}
			RpcEndExcept;
			//break;

		case IDCANCEL:
			EndDialog(hDlg_, LOWORD(wParam_));
			break;

		case IDC_PWD:
			if(HIWORD(wParam_) == EN_CHANGE)
			{
				fUsePasswd = TRUE;
			};
			break;

		case IDC_ASTERISKS_CHECK:
			if(HIWORD(wParam_) == BN_CLICKED)
			{
				g_fAsterisks = (BOOL)SendDlgItemMessage(hDlg_, IDC_ASTERISKS_CHECK, BM_GETCHECK, 0, 0);
				SendDlgItemMessage(hDlg_, IDC_PWD, EM_SETPASSWORDCHAR, 
								   (WPARAM)(g_fAsterisks ? _T('*') : _T(0)), 0);
				SetFocus(GetDlgItem(hDlg_, IDC_PWD));
			};
			break;

		case IDC_BROWSE:
			{
				TCHAR	szFile[MAX_PATH+1];
				TCHAR	szTitle[MAX_LOADSTRING];
				TCHAR	szFilter[MAX_LOADSTRING];

				ZeroMemory(szFilter, sizeof(szFilter));
				LoadString(g_hInst, IDS_FILE_FILTER, szFilter, MAX_LOADSTRING);
				LoadString(g_hInst, IDS_OPEN_KEY_FILE_TITLE, szTitle, MAX_LOADSTRING);
				if(ShowOpenFileDlg(hDlg_, szFile, MAX_PATH, szFilter, szTitle, 0))
				{
					cfdprintf("File: %s", szFile);

					HANDLE hFile = CreateFile(szFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
					
					if(hFile == INVALID_HANDLE_VALUE)
					{
						// Error...
					}
					else
					{
						DWORD dwFileSize;

						dwFileSize = GetFileSize(hFile, NULL);
						if(dwFileSize == 0)
                            MessageBox(NULL, _T("  ."), _T("Botik::Key Pro..."), MB_OK|MB_ICONHAND);
						else
						{
							DWORD dwReadedSz;

							ZeroMemory(szHash, sizeof(szHash));
							SetDlgItemText(hDlg_, IDC_PWD, _T(""));
							ReadFile(hFile, szHash, ABK_MD5_HASH_LEN, &dwReadedSz, NULL);
							fUsePasswd = FALSE;
						};

						CloseHandle(hFile);
					};
				};
			};
			break;
		};
		break;
	};

	return(FALSE);
};

/*
// Message handler proc for license box.
LRESULT CALLBACK SysInfoDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	switch (uMsg_)
	{
	case WM_INITDIALOG:
		{
			
		};
		return(TRUE);

	case WM_COMMAND:
		if (LOWORD(wParam_) == IDOK || LOWORD(wParam_) == IDCANCEL) 
		{
			EndDialog(hDlg_, LOWORD(wParam_));
			return(TRUE);
		};
		break;
	};

	return(FALSE);
};

VOID QuerySistemInformation()
{
	HINSTANCE		hInst;
	MEMORYSTATUS	msMemStat;
	DWORD			dwSize;

	ZeroMemory(&g_SysInfo, sizeof(BKPSYSTEMINFO));

	// Get memory information.
	ZeroMemory(&msMemStat, sizeof(MEMORYSTATUS));
	msMemStat.dwLength = sizeof(MEMORYSTATUS);
	GlobalMemoryStatus(&msMemStat);

	g_SysInfo.dwRAMInst = msMemStat.dwTotalPhys/1024/1024;
	g_SysInfo.dwRAMAvl  = msMemStat.dwAvailPhys/1024;
	g_SysInfo.dwRAMLoad = msMemStat.dwMemoryLoad;

	// Get IE version information.
	hInst = LoadLibrary(_T("shdocvw.dll"));
	if(hInst)
	{
		DLLGETVERSIONPROC pDllGetVersion;

		pDllGetVersion = (DLLGETVERSIONPROC)GetProcAddress(hInst, _T("DllGetVersion"));
		if(pDllGetVersion)
		{
			DLLVERSIONINFO dvi;

			ZeroMemory(&dvi, sizeof(dvi));
			dvi.cbSize = sizeof(dvi);

			if(SUCCEEDED((*pDllGetVersion)(&dvi)))
			{
				g_SysInfo.dwIEMajor = dvi.dwMajorVersion;
				g_SysInfo.dwIEMinor = dvi.dwMinorVersion;
				g_SysInfo.dwIEBuild = dvi.dwBuildNumber;
			};
		};

		FreeLibrary(hInst);
	}; // Get IE version information.

	// Get user name information.
	dwSize = UNLEN + 1;
	if(!GetUserName(g_SysInfo.szUserName, &dwSize))
		_tcscpy(g_SysInfo.szUserName, _T("N/A"));

	// Get computer name.
	dwSize = MAX_COMPUTERNAME_LENGTH + 1;
	if(!GetComputerName(g_SysInfo.szCompName, &dwSize))
		_tcscpy(g_SysInfo.szCompName, _T("N/A"));
};
*/

/*

Botik::Key Pro (%d.%d.%d.%d) Report.
====================================
UserName=%s
ComputerName=%s
OS=Windows NT Service Pack 1 Version: 5.010000
AppDir=%s
WinDir=%s
UserDefaultLangID=1049
SystemDefaultLangID=1049
ACP=1251 OEMCP=866
Internet Explorer=

Hardware:
CPU Vendor=GenuineIntel
CPU Identifier=x86 Family 15 Model 1 Stepping 3
CPU=983299
RAM=368 Mb

*/