/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* manager.cpp : Defines the entry point for the application.
 */

#include "stdafx.h"
#include "main_dlg.h"
#include "opt_tab_access_dlg.h"
#include "message_dispatcher.h"
#include "logviewer.h"
#include "interface_h.h"

// Global variables.
HINSTANCE	g_hInst;
HICON		g_hBigIcon;
HICON		g_hSmallIcon;
INT			g_nCurAccess;
INT			g_nReqAccess;
HKEY		g_hKeyCurUsr;
HKEY		g_hKeyLocMch;
HKEY		g_hKeyAS;
BOOL		g_fIsWinNT;
BOOL		g_fIs2K;
DWORD		g_dwSP = 0;
BOOL		g_fBlnEnbl;
DWORD		g_dwSvcStatus;
TCHAR		g_szChmPath[MAX_PATH+1];
INT			g_nLastNewVer;
BOOL		g_fSysParamsRO = FALSE;

INT			g_nStartupMode;
BOOL		g_fHideMin;
BOOL		g_fHideClose;
BOOL		g_fOneClick;
BOOL		g_fForceLogviewer;
BOOL		g_fAsterisks;
INT			g_nSwitchClose;
INT			g_nSwitchStart;
INT			g_nSvcSwitchStart;
INT			g_nPasswdPlace;
LPTSTR		g_szPasswdFile;
LPTSTR		g_szPasswd;
BOOL		g_fUseStdPort;
BOOL		g_fUseGWAddr;
LONG		g_nPortNumber;
LPTSTR		g_szSrvAddress;
BOOL		g_fWriteLogFile;
BOOL		g_fInformMngr;
BOOL		g_fSvcConfChanged;
BOOL		g_fMgrConfChanged;


LRESULT CALLBACK RunningDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_);


INT APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPTSTR lpCmdLine, INT nCmdShow)
{
	MSG						msg;
	LONG					lRet;
	HANDLE					hMutex;
	BOOL					fOsVerInfoEx;
	TCHAR					szMutexName[MAX_PATH+1];
	HACCEL					hAccelTableLV;
	HACCEL					hAccelTableMD;
	OSVERSIONINFOEX			ovi;
	INITCOMMONCONTROLSEX	icce;

	// State definition.
	g_hInst = hInstance;

	g_fExit = FALSE;
	g_fMngrConnected = FALSE;
	g_dwSvcStatus = ABK_SVC_STOPPED;
	g_nLastNewVer = 0;

	// XXX Dbg.
	g_nCurAccess = ABK_ACCESS_UNSPEC;
    g_nReqAccess = ABK_ACCESS_UNSPEC;

	// Get to know what platform we are running on (9x,NT).
	// Try calling GetVersionEx using the OSVERSIONINFOEX structure.
	// If that fails, try using the OSVERSIONINFO structure.
	ZeroMemory(&ovi, sizeof(OSVERSIONINFOEX));
	ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

	if(!(fOsVerInfoEx = GetVersionEx((LPOSVERSIONINFO)&ovi)))
	{
		ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
		if(!GetVersionEx((LPOSVERSIONINFO)&ovi))
			return(FALSE);
	};

	// Get platform flag.
	if(ovi.dwPlatformId == VER_PLATFORM_WIN32_NT)
		g_fIsWinNT = TRUE;
	else
		g_fIsWinNT = FALSE;

	// Get to know wa are running on Win2K or later.
	if(ovi.dwMajorVersion >= 5)
		g_fIs2K = TRUE;
	else 
		g_fIs2K = FALSE;

	// Get Service Pack version number.
	if(fOsVerInfoEx)
		g_dwSP = ovi.wServicePackMajor << 16 | ovi.wServicePackMinor;
	cfdprintf(_T("main: Service Pack Version: 0x%x"), g_dwSP);

	// XXX Debug Win9x behaviour on NT.
	//g_fIsWinNT = FALSE;
	//g_fIs2K    = FALSE;
	//g_dwSP     = 0;

	icce.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icce.dwICC  = ICC_ANIMATE_CLASS|ICC_BAR_CLASSES|ICC_COOL_CLASSES|ICC_DATE_CLASSES|ICC_HOTKEY_CLASS|
					ICC_INTERNET_CLASSES|ICC_LINK_CLASS|ICC_LISTVIEW_CLASSES|ICC_NATIVEFNTCTL_CLASS|
					ICC_PAGESCROLLER_CLASS|ICC_PROGRESS_CLASS|ICC_STANDARD_CLASSES|ICC_TAB_CLASSES|
					ICC_TREEVIEW_CLASSES|ICC_UPDOWN_CLASS|ICC_USEREX_CLASSES|ICC_WIN95_CLASSES;

	InitCommonControlsEx(&icce);

	// load UxTheme.dll to get pointer to the EnableThemeDialogTexture function
	HMODULE hDLL;
	hDLL = ::LoadLibrary("UxTheme");
	pEnableThemeDialogTexture = (PETDT)::GetProcAddress(hDLL, "EnableThemeDialogTexture");
	if(pEnableThemeDialogTexture)
        cfdprintf(_T("main: EnableThemeDialogTexture initialization succeeded."));
    else
        cfdprintf(_T("main: EnableThemeDialogTexture initialization failed."));

	// Check, if a balloon API disabled (XXX)
	// HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\EnableBalloonTips 0x0
	// If EnableBalloonTips value is not available, so it means that API enabled.
	// If EnableBalloonTips value is available, and contains 0, API disabled.
	HKEY hKey;
	g_fBlnEnbl = FALSE;
	lRet = RegCreateKeyEx(HKEY_CURRENT_USER, 
						  _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Advanced"), 
						  0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, 
						  NULL, &hKey, NULL);
	if(lRet == ERROR_SUCCESS)
		lRet = cfRegReadDWVal(hKey, _T("EnableBalloonTips"), (LPDWORD)&g_fBlnEnbl, 1);
	RegCloseKey(hKey);

	if(!g_fIs2K)
		g_fBlnEnbl = 0;

	// If we are running on Windows 2000 and later, make global mutex.
	if(ovi.dwMajorVersion >= 5)
	{
		_tcscpy(szMutexName, _T("Global\\"));
		_tcscat(szMutexName, ABK_MNGR_MUTEX_NAME);
	}
	else
	{
		_tcscpy(szMutexName, ABK_MNGR_MUTEX_NAME);
	};

	// Check if this is first instance. If allready there is another instance, exit.
	hMutex = CreateMutex(NULL, FALSE, szMutexName);
	if(GetLastError() != 0)
	{
        HWND hwnd = FindWindow(NULL, _T("Botik::Key Pro -   ...")); // XXX

		if(hwnd == NULL)
		{
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_RUNNING_DLG), NULL, (DLGPROC)RunningDlg);
		}
		else
		{
			ShowWindow(hwnd, SW_RESTORE);
			ShowWindow(hwnd, SW_SHOW);
			SetForegroundWindow(hwnd);
		};

		return(FALSE);
	};

	GetModuleFileName(g_hInst, g_szChmPath, MAX_PATH);
	*_tcsrchr(g_szChmPath, _T('\\')) = _T(0);
	_tcscat(g_szChmPath, _T("\\help.chm"));

	// Opens registry keys to read settings.
	lRet = RegCreateKeyEx(HKEY_CURRENT_USER, REG_SETTINGS_PATH, 0, NULL, 
						  REG_OPTION_NON_VOLATILE, KEY_WRITE|KEY_READ, 
						  NULL, &g_hKeyCurUsr, NULL);
	cfCHECK_RET(lRet);

	cfdprintf("before param read 2");

	// Ask for read/write access. If it failed, ask for read only access.
	lRet = RegCreateKeyEx(HKEY_LOCAL_MACHINE, REG_SETTINGS_PATH, 0, NULL, 
						  REG_OPTION_NON_VOLATILE, KEY_WRITE|KEY_READ, 
						  NULL, &g_hKeyLocMch, NULL);
	if(lRet != ERROR_SUCCESS)
	{
		g_fSysParamsRO = TRUE;

		cfdprintf("lRet: %d", lRet);

		lRet = RegCreateKeyEx(HKEY_LOCAL_MACHINE, REG_SETTINGS_PATH, 0, NULL, 
							  REG_OPTION_NON_VOLATILE, KEY_READ, NULL, 
							  &g_hKeyLocMch, NULL);

		cfCHECK_RET(lRet);
	};

//	g_fSysParamsRO = TRUE;

	lRet = RegCreateKeyEx(HKEY_CURRENT_USER, REG_AUTOSTART_PATH, 0, NULL, 
						  REG_OPTION_NON_VOLATILE, KEY_WRITE|KEY_READ, 
						  NULL, &g_hKeyAS, NULL);
	cfCHECK_RET(lRet);

	// Read user's saved settings.
	cfRegReadDWVal(g_hKeyCurUsr, REG_STARTUP_MODE_VAL, (LPDWORD)&g_nStartupMode, ABK_MNGR_STARTUP_NORMAL);
	cfRegReadDWVal(g_hKeyCurUsr, REG_HIDE_MIN_VAL, (LPDWORD)&g_fHideMin, 0);
	cfRegReadDWVal(g_hKeyCurUsr, REG_HIDE_CLOSE_VAL, (LPDWORD)&g_fHideClose, 1);
	cfRegReadDWVal(g_hKeyCurUsr, REG_ONE_CLICK_VAL, (LPDWORD)&g_fOneClick, 0);
	cfRegReadDWVal(g_hKeyCurUsr, REG_FORCE_LOGVIEWER_VAL, (LPDWORD)&g_fForceLogviewer, 1);
	cfRegReadDWVal(g_hKeyCurUsr, REG_ASTERISKS_VAL, (LPDWORD)&g_fAsterisks, 1);
	cfRegReadDWVal(g_hKeyCurUsr, REG_SWITCH_WHEN_CLOSE_VAL, (LPDWORD)&g_nSwitchClose, 0);
	cfRegReadDWVal(g_hKeyCurUsr, REG_SWITCH_WHEN_START_VAL, (LPDWORD)&g_nSwitchStart, 0);

	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_CX_VAL, &g_dwWinCxLV, 500);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_CY_VAL, &g_dwWinCyLV, 400);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_ISMAX_VAL, (LPDWORD)&g_fIsMaximized, FALSE);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_TOOLBAR_VAL, (LPDWORD)&g_fToolbar, TRUE);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_STATUSBAR_VAL, (LPDWORD)&g_fStatusbar, TRUE);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_AUTOSCROLL_VAL, (LPDWORD)&g_fAutoscroll, TRUE);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_FIRST_COL_VAL, (LPDWORD)&g_dwFirstColWidth, 120);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_SECOND_COL_VAL, (LPDWORD)&g_dwSecondColWidth, 300);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_MAX_ENTRY, &g_dwMaxEventsShow, 100);
	cfRegReadDWVal(g_hKeyCurUsr, REG_LOGVIEWER_PLAYSOUND, (LPDWORD)&g_fPlaySound, FALSE);

	// Read global saved settings.
	cfRegReadDWVal(g_hKeyLocMch, REG_PASSWD_PLACE_VAL, (LPDWORD)&g_nPasswdPlace, 0);
	cfRegReadDWVal(g_hKeyLocMch, REG_SWITCH_WHEN_SVC_START_VAL, (LPDWORD)&g_nSvcSwitchStart, 0);
	cfRegReadDWVal(g_hKeyLocMch, REG_BKEY_SRV_PORT_USE_STD, (LPDWORD)&g_fUseStdPort, 1);
	cfRegReadDWVal(g_hKeyLocMch, REG_BKEY_SRV_USE_DEF_GW_ADDR, (LPDWORD)&g_fUseGWAddr, 1);
	cfRegReadDWVal(g_hKeyLocMch, REG_BKEY_SRV_PORT, (LPDWORD)&g_nPortNumber, ABK_BKEY_SRV_DEF_PORT);
	cfRegReadSTRVal(g_hKeyLocMch, REG_BKEY_SRV_ADDR, &g_szSrvAddress, _T(""));
	cfRegReadDWVal(g_hKeyLocMch, REG_BKEY_SRV_WRITE_LOG, (LPDWORD)&g_fWriteLogFile, FALSE);
	cfRegReadDWVal(g_hKeyLocMch, REG_BKEY_SRV_INFORM_MNGR, (LPDWORD)&g_fInformMngr, TRUE);

	g_hMainDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_MAIN_DLG), NULL, (DLGPROC)WndProcMD);

	if(!g_hMainDlg)
	{
		cfdprintf("CreateDialog failed.");
		return FALSE;
	};

	// Window is hided on startup by default.
	if(g_nStartupMode == ABK_MNGR_STARTUP_NORMAL)
		ShowWindow(g_hMainDlg, SW_SHOW);
	else if(g_nStartupMode == ABK_MNGR_STARTUP_MIN)
		ShowWindow(g_hMainDlg, SW_MINIMIZE);

	UpdateWindow(g_hMainDlg);

	hAccelTableLV = LoadAccelerators(hInstance, (LPCTSTR)IDR_LOGVIEWER);
	hAccelTableMD = LoadAccelerators(hInstance, (LPCTSTR)IDR_MANAGER);

	// Main message loop.
	while(GetMessage(&msg, NULL, 0, 0)) 
	{
		HWND hWnd = GetForegroundWindow();
		HACCEL hAccelTable = NULL;

		if(hWnd == g_hwndLogViewer)
			hAccelTable = hAccelTableLV;
		if(hWnd == g_hMainDlg)
			hAccelTable = hAccelTableMD;

		if(!TranslateAccelerator(hWnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		};
	};

	// Save some values...
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_CX_VAL, g_dwWinCxLV);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_CY_VAL, g_dwWinCyLV);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_ISMAX_VAL, g_fIsMaximized);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_TOOLBAR_VAL, g_fToolbar);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_STATUSBAR_VAL, g_fStatusbar);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_AUTOSCROLL_VAL, g_fAutoscroll);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_FIRST_COL_VAL, g_dwFirstColWidth);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_LOGVIEWER_SECOND_COL_VAL, g_dwSecondColWidth);

	// Cleanup...
	RegCloseKey(g_hKeyCurUsr);
	RegCloseKey(g_hKeyLocMch);
	RegCloseKey(g_hKeyAS);

	CloseHandle(hMutex);

	return((INT)msg.wParam);
};

BOOL SetAccessMode(INT nMode_)
{
	ULONG ulCode;

	cfdprintf("SetAccessMode: Desired Access Mode: %d", nMode_);

	if(g_nReqAccess != nMode_)
	{
//		g_nCurAccess = nMode_ | ABK_ACCESS_CHANGING;
        g_nCurAccess = g_nCurAccess | ABK_ACCESS_CHANGING;
        g_nReqAccess = nMode_;// | ABK_ACCESS_CHANGING;
		DisplayCurrentAccessMode(g_hAccTabDlg);

		RpcTryExcept
		{
			SvcSetAccessMode(nMode_);
		}
		RpcExcept(1)
		{
			ulCode = RpcExceptionCode();
			g_nCurAccess = ABK_ACCESS_UNSPEC;
            g_nReqAccess = ABK_ACCESS_UNSPEC;
			DisplayCurrentAccessMode(g_hAccTabDlg);
		}
		RpcEndExcept;
	};

	return(1);
};

// Message handler proc for "we are allready running box".
LRESULT CALLBACK RunningDlg(HWND hDlg_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	switch (uMsg_)
	{
	case WM_INITDIALOG:
		return(TRUE);

	case WM_COMMAND:
		if (LOWORD(wParam_) == IDOK || LOWORD(wParam_) == IDCANCEL) 
		{
			EndDialog(hDlg_, LOWORD(wParam_));
			return(TRUE);
		};
		break;
	};

	return(FALSE);
};

VOID RunPwd2KeyUtil(VOID)
{
	TCHAR szPath[MAX_PATH];
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	GetModuleFileName(g_hInst, szPath, MAX_PATH);
	*_tcsrchr(szPath, _T('\\')) = 0;
	_tcscat(szPath, _T("\\pw2key32.exe"));

	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(si);
	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));

	if(!CreateProcess(szPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
	{
		// XXX Localization...
		cfAlertBoxError(ABK_SERVICE_NAME, 
						_T("    ."), 
						GetLastError());
	};
};

BOOL DoStartupService(VOID)
{
	BOOL fRet = TRUE;

	if(g_fIsWinNT)
	{
		SC_HANDLE  schSCMngr, schSvc;

		cfdprintf("DoStartupService as NT");

		schSCMngr = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if(schSCMngr == NULL)
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());

			return(FALSE);
		};

		schSvc = OpenService(schSCMngr, ABK_SERVICE_NAME_FOR_SCM, SERVICE_START);
		if(schSvc == NULL) 
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());

			return(FALSE);
		};

		if(!StartService(schSvc, 0, NULL))
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());

			fRet = FALSE;
		};

		CloseServiceHandle(schSvc);
		CloseServiceHandle(schSCMngr);
	}
	else
	{
		TCHAR szPath[MAX_PATH];
		STARTUPINFO si;
		PROCESS_INFORMATION pi;

		GetModuleFileName(g_hInst, szPath, MAX_PATH);

		*_tcsrchr(szPath, _T('\\')) = _T(0);
		_tcscat(szPath, _T("\\bkpsvc32.exe"));

		ZeroMemory(&si, sizeof(STARTUPINFO));
		si.cb = sizeof(si);
		ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));

		if(!CreateProcess(szPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());

			fRet = FALSE;
		};

		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	};

	return(fRet);
};

BOOL DoShutdownService(VOID)
{
	BOOL fRet = TRUE;
	SC_HANDLE  schSCMngr, schSvc;
	SERVICE_STATUS ss;

	g_fIsWinNT;

	if(g_fIsWinNT) // If we are running on a Windows NT call SCM to stop manager.
	{
		// Open SCM.
		schSCMngr = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if(schSCMngr == NULL)
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());

			return(FALSE);
		};

		// Open service.
		schSvc = OpenService(schSCMngr, ABK_SERVICE_NAME_FOR_SCM, SERVICE_STOP|SERVICE_QUERY_STATUS);
		if(schSvc == NULL) 
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());

			return(FALSE);
		};

		// Query service status to determine the next uninstallation step.
		if(!QueryServiceStatus(schSvc, &ss))
		{
			cfAlertBoxError(ABK_SERVICE_NAME, 
							_T("   ."), 
							GetLastError());
	
			return(FALSE);
		}
		else
		{
			// If service status is not stopped, so performe stop call.
			// XXX Is this ok to compare to SERVICE_STOPPED only?
			if(ss.dwCurrentState != SERVICE_STOPPED)
			{
				cfdprintf("Stopping as NT");

				if(!ControlService(schSvc, SERVICE_CONTROL_STOP, &ss))
				{
					cfAlertBoxError(ABK_SERVICE_NAME, 
									_T("   ."), 
									GetLastError());

					return(FALSE);
				};
			}
			else // We doesn't success our mission... Service was already stopped.
			{
				return(FALSE);
			};
		}; // if(!QueryServiceStatus(schSvc, &ss))
	}
	else
	{
		RpcTryExcept
		{
			cfdprintf("Stopping as 9x");
			fRet = SvcStopService();
		}
		RpcExcept(1)
		{
			fRet = FALSE;
		}
		RpcEndExcept;
	};

	return fRet;
};
