/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "message_dispatcher.h"
#include "interface_h.h"
#include <process.h>
#include "main_dlg.h"


HANDLE	g_hMsgDispThrd;
BOOL	g_fMngrConnected;

unsigned int __stdcall __MessageDispatcherThrd(void*);

BOOL StartMessageDispatching(VOID)
{
	unsigned int thrdid;

	g_hMsgDispThrd = (HANDLE)_beginthreadex(NULL, 0, __MessageDispatcherThrd, NULL, 0, &thrdid);

	if(g_hMsgDispThrd != (HANDLE)-1)
		return(TRUE);

	return(FALSE);
};

unsigned int __stdcall __MessageDispatcherThrd(void*)
{
	RPC_STATUS rpcs;

	// on vista ms depricates sync ncalrpc, now use named pipes
	unsigned char* pszUuid       = (unsigned char*)"9c13db6e-2f5f-434f-8e55-0fbe2816ea5b";
    unsigned char* pszProtSeq;//    = (unsigned char*)"ncacn_np"; // "ncalrpc"; // "ncacn_np";
	unsigned char* pszEndpoint;//   = (unsigned char*)"\\pipe\\BotikKeyPro"; //"BotikKeyPro"; // "\\pipe\\hello";

	if(g_fIsWinNT)
	{
		pszProtSeq  = (unsigned char*)"ncacn_np"; //"ncalrpc";     // "ncacn_np";
		pszEndpoint = (unsigned char*)"\\pipe\\BotikKeyPro"; //"BotikKeyPro"; // "\\pipe\\hello";
	}
	else
	{
		pszProtSeq  = (unsigned char*)"ncalrpc";     // "ncacn_np";
		pszEndpoint = (unsigned char*)"BotikKeyPro"; // "\\pipe\\hello";
	}

    unsigned char* pszNetAddr    = (unsigned char*)NULL;
    unsigned char* pszOptions    = (unsigned char*)NULL;
    unsigned char* pszStrBinding = (unsigned char*)NULL;

	unsigned long ulCode;

	cfdprintf("Start of __MessageDispatcherThrd");

	rpcs = RpcStringBindingCompose(pszUuid, pszProtSeq, pszNetAddr, pszEndpoint, 
								   pszOptions, &pszStrBinding);

	if(rpcs != RPC_S_OK)
	{
		cfdprintf("RpcStringBindingCompose failed: %d\n", rpcs);
		return(1);
	};

	rpcs = RpcBindingFromStringBinding(pszStrBinding, &AbkService_IfHandle);

	if(rpcs != RPC_S_OK)
	{
		cfdprintf("RpcBindingFromStringBinding failed: %d\n", rpcs);
		return(1);
	};

	while(!g_fMngrConnected)
	{
		cfdprintf("__MessageDispatcherThrd trying to connect.");

		RpcTryExcept
		{
			SvcMessageDispatcher();
		}
		RpcExcept(1)
		{
			// Set timer to reconnect later.
			ulCode = RpcExceptionCode();
			cfdprintf("Call to SvcMessageDispatcher failed [%d]. Sleep for a while.", ulCode);
			Sleep(2000);
		}
		RpcEndExcept;
	};

	g_fMngrConnected = FALSE;

	RpcStringFree(&pszStrBinding);
	RpcBindingFree(&AbkService_IfHandle);

	SendMessage(g_hMainDlg, WM_USER_SVC_STOPPED, 0, 0);

	if(g_fExit)
	{
		cfdprintf("__MessageDispatcherThrd kill main dialog.");
		SendMessage(g_hMainDlg, WM_USER_KILL_MANAGER, 0, 0);
	};

	cfdprintf("End of __MessageDispatcherThrd");

	return(0);
};




