/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "opt_tab_pwd_dlg.h"
#include "main_dlg.h"

HWND g_hPwdTabDlg;

HWND CreatePwdTab(HWND hPrnWnd_)
{
	g_hPwdTabDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_OPT_TAB_PWD), 
								hPrnWnd_, (DLGPROC)WndProcPT);

	if(g_hPwdTabDlg && pEnableThemeDialogTexture)
		pEnableThemeDialogTexture(g_hPwdTabDlg, 6);

	return g_hPwdTabDlg;
};

LRESULT CALLBACK WndProcPT(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch (uMsg_) 
	{
	case WM_INITDIALOG:
		return OnInitDialogPT(hWnd_, wParam_, lParam_);

	case WM_COMMAND:
		OnCommandPT(hWnd_, wParam_, lParam_);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd_, &ps);
		EndPaint(hWnd_, &ps);
		break;
	};

	return FALSE;
};

LRESULT OnInitDialogPT(HWND hWnd_, WPARAM wParam_, LPARAM lParam_)
{
	//HANDLE hImg;

	// Draw icons.
	//hImg = LoadImage(g_hInst, MAKEINTRESOURCE(IDB_STARTUP_LOGO_NORM), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE|LR_LOADMAP3DCOLORS);
	//hImg = (HANDLE)SendDlgItemMessage(hWnd_, IDC_STATIC_PIC3, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hImg);
	//if(hImg)
	//	DeleteObject(hImg);

	UpdateGUIPT(hWnd_);

	return TRUE;
};

VOID UpdateGUIPT(HWND hWnd_)
{
	LPTSTR szBuf;

    // XXX some strange behaviour, if radio button disabled
    // SendDlgItemMessage with BM_CLICK will be blocked!!!
    // as a temporary solution, i added fDisabled variable to 
    // show that radio buttons already disabled, so dont change
    // their status!
    static BOOL fDisabled = FALSE;
//	__asm int 3;
    if(!fDisabled)
    {
	    if(g_nPasswdPlace == ABK_PASSWD_PLACE_SELF)
		    SendDlgItemMessage(hWnd_, IDC_PWD_RADIO1, BM_CLICK, 1, 0);
	    else if(g_nPasswdPlace == ABK_PASSWD_PLACE_ENV)
		    SendDlgItemMessage(hWnd_, IDC_PWD_RADIO2, BM_CLICK, 1, 0);
	    else if(g_nPasswdPlace == ABK_PASSWD_PLACE_REG)
		    SendDlgItemMessage(hWnd_, IDC_PWD_RADIO3, BM_CLICK, 1, 0);
	    else if(g_nPasswdPlace == ABK_PASSWD_PLACE_DEF_FILE)
		    SendDlgItemMessage(hWnd_, IDC_PWD_RADIO4, BM_CLICK, 1, 0);
	    else if(g_nPasswdPlace == ABK_PASSWD_PLACE_SELF_FILE)
		    SendDlgItemMessage(hWnd_, IDC_PWD_RADIO5, BM_CLICK, 1, 0);
    };

	if(g_nPasswdPlace == ABK_PASSWD_PLACE_SELF || g_nPasswdPlace == ABK_PASSWD_PLACE_ENV)
		cfEnableDlgItem(hWnd_, IDC_SAVE_PWD, FALSE);
	else
		cfEnableDlgItem(hWnd_, IDC_SAVE_PWD, TRUE);

	cfRegReadSTRVal(g_hKeyLocMch, REG_PASSWD_FILE_VAL, &szBuf, _T(""));
	SetDlgItemText(hWnd_, IDC_FILE_NAME, szBuf);
	delete[] szBuf;

	// If user doesn't have priveleged access, just show params.
	if(g_fSysParamsRO)
	{
        fDisabled = TRUE;
		cfEnableDlgItem(hWnd_, IDC_PWD_RADIO1, FALSE);
		cfEnableDlgItem(hWnd_, IDC_PWD_RADIO2, FALSE);
		cfEnableDlgItem(hWnd_, IDC_PWD_RADIO3, FALSE);
		cfEnableDlgItem(hWnd_, IDC_PWD_RADIO4, FALSE);
		cfEnableDlgItem(hWnd_, IDC_PWD_RADIO5, FALSE);
		cfEnableDlgItem(hWnd_, IDC_BROWSE_SPEC, FALSE);
		cfEnableDlgItem(hWnd_, IDC_FILE_NAME, FALSE);
	};
};

LRESULT OnCommandPT(HWND hWnd_, WPARAM wParam_, LPARAM lParam_)
{
	if(HIWORD(wParam_) == BN_CLICKED)
	{
		switch(LOWORD(wParam_))
		{
		case IDC_PWD_RADIO1:
		case IDC_PWD_RADIO2:
		case IDC_PWD_RADIO3:
		case IDC_PWD_RADIO4:
			cfEnableDlgItem(hWnd_, IDC_FILE_NAME, FALSE);
			cfEnableDlgItem(hWnd_, IDC_SAVE, FALSE);
			cfEnableDlgItem(hWnd_, IDC_BROWSE_SPEC, FALSE);

			g_fSvcConfChanged = TRUE;
			break;

		case IDC_PWD_RADIO5:
			cfEnableDlgItem(hWnd_, IDC_FILE_NAME, TRUE);
			cfEnableDlgItem(hWnd_, IDC_SAVE, TRUE);
			cfEnableDlgItem(hWnd_, IDC_BROWSE_SPEC, TRUE);

			g_fSvcConfChanged = TRUE;
			break;

		case IDC_SHOW_PWD_DLG:
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_PWD_DLG), hWnd_, (DLGPROC)SetPasswdDlg);
			break;

		case IDC_SHOW_PWD2KEY:
			{
				RunPwd2KeyUtil();
			};
			break;

		case IDC_BROWSE_SPEC:
			{
				TCHAR	szFile[MAX_PATH+1];
				TCHAR	szTitle[MAX_LOADSTRING+1];
				TCHAR	szFilter[MAX_LOADSTRING+1];

				ZeroMemory(szFilter, sizeof(szFilter));
				LoadString(g_hInst, IDS_FILE_FILTER, szFilter, MAX_LOADSTRING);
				LoadString(g_hInst, IDS_OPEN_KEY_FILE_TITLE, szTitle, MAX_LOADSTRING);
				if(ShowOpenFileDlg(hWnd_, szFile, MAX_PATH, szFilter, szTitle, 0))
				{
					SetDlgItemText(hWnd_, IDC_FILE_NAME, szFile);
					g_fSvcConfChanged = TRUE;
				};
			};
			break;
		};
	};

	if(g_fSvcConfChanged)
		cfEnableDlgItem(g_hMainDlg, IDAPPLAY, TRUE);

	return 0;
};


